Subject: bug#56397: 28.1; Incorrect behavior of buffer-modified-p after undo in indirect buffer

From: Eli Zaretskii <[email-masked]>
Date: Thu, 07 Jul 2022 11:59:02 +0300

> From: Bill Sacks <[email-masked]>
> Date: Tue, 5 Jul 2022 07:24:29 -0600
> 
> When working in a cloned indirect buffer, if I type something then save the buffer then undo my changes,
> buffer-modified-p returns nil and I am not able to save the version with these changes undone.
> 
> Steps to reproduce:
> 
> 1. Create a text buffer with some text in it (e.g., test.txt) and save it
> 2. Clone the buffer with M-x clone-indirect-buffer
> 3. Type some more text into the indirect buffer (e.g., test.txt<2>) and save it with C-x C-s
> 4. While still in the indirect buffer, undo the text entered in (3) with C-/ until the buffer has returned to the state
> at the start of (3)
> 5. Notice that (buffer-modified-p) returns nil. Attempting to save the buffer gives the message "(No changes
> need to be saved)". However, viewing the file on disk shows that it is still at the state from the end of (3).

Thanks, I think I've now fixed this on the master branch.